//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.UnobservableCommandTest.UnobservableCommandTest
{
    
    
    /// <summary>
    /// Class that implements the IUnobservableCommandTest interface through SiLA2
    /// </summary>
    public partial class UnobservableCommandTestClient : IUnobservableCommandTest
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.unobservablecommandtest.v1.UnobservableCommandTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public UnobservableCommandTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// A command that takes no parameters and returns no responses
        /// </summary>
        public virtual void CommandWithoutParametersAndResponses()
        {
            CommandWithoutParametersAndResponsesRequestDto request = new CommandWithoutParametersAndResponsesRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/UnobservableCommandTest/v1/Command/CommandWithoutParameters" +
                    "AndResponses");
            try
            {
                _channel.ExecuteUnobservableCommand<CommandWithoutParametersAndResponsesRequestDto>(_serviceName, "CommandWithoutParametersAndResponses", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// A command that takes one integer parameter and returns its string representation.
        /// </summary>
        /// <param name="integer">An integer, e.g. 12345</param>
        public virtual string ConvertIntegerToString(long integer)
        {
            ConvertIntegerToStringRequestDto request = new ConvertIntegerToStringRequestDto(integer, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/UnobservableCommandTest/v1/Command/ConvertIntegerToString");
            try
            {
                string response = _channel.ExecuteUnobservableCommand<ConvertIntegerToStringRequestDto, ConvertIntegerToStringResponseDto>(_serviceName, "ConvertIntegerToString", request, callInfo).StringRepresentation.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// A command which takes an integer and a string parameter and returns a string with both joined (e.g.
        /// "123abc")
        /// </summary>
        /// <param name="integer">An integer, e.g. 123</param>
        /// <param name="string">A string, e.g. 'abc'</param>
        public virtual string JoinIntegerAndString(long integer, string @string)
        {
            JoinIntegerAndStringRequestDto request = new JoinIntegerAndStringRequestDto(integer, @string, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString");
            try
            {
                string response = _channel.ExecuteUnobservableCommand<JoinIntegerAndStringRequestDto, JoinIntegerAndStringResponseDto>(_serviceName, "JoinIntegerAndString", request, callInfo).JoinedParameters.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// A command which splits a given string after its first character. Returns empty parts if the input was
        /// too short.
        /// </summary>
        /// <param name="string">A string, e.g. 'abcde'</param>
        public virtual SplitStringAfterFirstCharacterResponse SplitStringAfterFirstCharacter(string @string)
        {
            SplitStringAfterFirstCharacterRequestDto request = new SplitStringAfterFirstCharacterRequestDto(@string, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/UnobservableCommandTest/v1/Command/SplitStringAfterFirstCha" +
                    "racter");
            try
            {
                SplitStringAfterFirstCharacterResponse response = _channel.ExecuteUnobservableCommand<SplitStringAfterFirstCharacterRequestDto, SplitStringAfterFirstCharacterResponseDto>(_serviceName, "SplitStringAfterFirstCharacter", request, callInfo).Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Unobservable Command Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class UnobservableCommandTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/UnobservableCommandTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IUnobservableCommandTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new UnobservableCommandTestClient(channel, executionManager);
        }
    }
}

